#include <string.h>
#include "../fatfs/ff.h"
#include "../fatfs/diskio.h"
#include "sys_ctrl.h"
#include "cmt0_ctrl.h"
#include "led_ctrl.h"
extern void power_off(void);

#ifdef HEW
#pragma inline_asm set_sp
static void set_sp(int a){MOV R4, R15}
#else
extern void set_sp(int sp);
#endif

void loader()
{
	int error;

	init_clk();
	init_led();
	init_cmt0();
//	irq_enable();

	error = 0;

	while(1)
	{
		char fname[] = "app.bin";
		FATFS fatfs;
		FRESULT res;

		if(0 == (disk_initialize(0) & (STA_NOINIT | STA_NODISK)))
		{
			res = f_mount(0, &fatfs);
			if(res == FR_OK)
			{
				FIL fobj;

				res = f_open(&fobj, fname, FA_READ);
				if(res == FR_OK)
				{
					UINT size;
					int tmp_vect[9];

					res = f_read(&fobj, (void*)tmp_vect, sizeof(tmp_vect), &size);
					if(res == FR_OK)
					{
						static int load_adr;
						load_adr = tmp_vect[8];

						memcpy((void*)load_adr, tmp_vect, sizeof(tmp_vect));
						res = f_read(
							&fobj,
							(void*)(load_adr + (int)sizeof(tmp_vect)),
							0x18100000 - (load_adr + (unsigned int)sizeof(tmp_vect)),
							&size
						);
						if(res == FR_OK)
						{
							static void (*p)();
							p = (void(*))(*(int*)load_adr);

							irq_disable();
							power_off();
							reset_cmt0();
							reset_led();
							reset_clk();

							set_sp(tmp_vect[1]);
							(p)();
						} else {
							/* read2 error! */
							error = 5;
						}
					} else {
						/* read1 error! */
						error = 4;
					}
					res = f_close(&fobj);
				} else {
					/* open error! */
					error = 3;
				}
			} else {
				/* mount error! */
				error = 2;
			}
		} else {
			/* disk initialize */
			error = 1;
		}
		#ifdef MONITOR
		ffmain();
		#endif
		delay_ms(1000);
		led_toggle();
	}
}
